'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;
exports['default'] = graphql;

var _parse = require('./parser');

var _parse2 = _interopRequireWildcard(_parse);

var _transform = require('./transform');

var _transform2 = _interopRequireWildcard(_transform);

var _import = require('graphql-types');

var _GraphQL = _interopRequireWildcard(_import);

exports.GraphQL = _GraphQL;
exports.parse = _parse2['default'];
exports.transform = _transform2['default'];

function graphql(strings) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  var source = strings[0] || '';
  for (var i = 1; i < strings.length; i++) {
    source += '&' + (i - 1);
    source += strings[i];
  }

  var ast = _parse2['default'](source);
  return function (params) {
    return _transform2['default'](ast, { args: args, params: params });
  };
}