'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;

var _Transform$simple$sequence$subtree = require('parsly/transform');

var _Transform$simple$sequence$subtree2 = _interopRequireWildcard(_Transform$simple$sequence$subtree);

var _import = require('graphql-types');

var GraphQL = _interopRequireWildcard(_import);

var isField = function isField(node) {
  return node.constructor === GraphQL.Field;
};
var isFragment = function isFragment(node) {
  return !isField(node);
};

var fields = function fields(nodes) {
  return Array.isArray(nodes) ? nodes.filter(isField) : [];
};
var fragments = function fragments(nodes) {
  return Array.isArray(nodes) ? nodes.filter(isFragment) : [];
};

var transform = new _Transform$simple$sequence$subtree2['default']([[function (node) {
  return _Transform$simple$sequence$subtree.simple(node.type) && _Transform$simple$sequence$subtree.sequence(node.fields);
}, function (node) {
  return new GraphQL.Fragment(node.type, fields(node.fields), fragments(node.fields));
}], [function (node) {
  return _Transform$simple$sequence$subtree.simple(node.identifier) && _Transform$simple$sequence$subtree.subtree(node.args) && _Transform$simple$sequence$subtree.sequence(node.fields);
}, function (node) {
  return new GraphQL.Query(node.identifier, node.args, fields(node.fields), fragments(node.fields));
}], [function (node) {
  return _Transform$simple$sequence$subtree.simple(node.identifier) && _Transform$simple$sequence$subtree.subtree(node.args);
}, function (node) {
  return new GraphQL.Call(node.identifier, node.args);
}], [function (node) {
  return _Transform$simple$sequence$subtree.simple(node.identifier);
}, function (node) {
  return new GraphQL.Field(node.identifier, fields(node.fields), fragments(node.fields), node.calls);
}], [function (node) {
  return _Transform$simple$sequence$subtree.simple(node.ref);
}, function (node, context) {
  return context.args[node.ref];
}], [function (node) {
  return _Transform$simple$sequence$subtree.simple(node.variable);
}, function (node, context) {
  return context.params[node.variable];
}], [function (node) {
  return _Transform$simple$sequence$subtree.simple(node.json);
}, function (node) {
  return JSON.parse(node.json);
}]]);

exports['default'] = function (ast, context) {
  return transform.run(ast, context);
};

module.exports = exports['default'];